<?php

namespace xenarabia\BestAnswer\XF\Widget;

class MostUsersAnswers extends \XF\Widget\AbstractWidget
{
	

    public function render()
    {
    	
		$MostUsersAnswers = $this->getQuery();
    	$viewParams = [
			'MostUsersAnswers' => $MostUsersAnswers,
			'node_id'	=> $this->contextParams['forum']['node_id']
    	];

        return $this->renderer('widget_most_users_answers', $viewParams);
    }

    public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
	{
		$options = $request->filter([
			'limit' => 'uint'
		]);

		return true;
	}


	protected function getQuery()
	{
		$forum_id = $this->contextParams['forum']['node_id'];
		$threads = \XF::db()->fetchAll("
		SELECT xf_user.*, COUNT(xf_thread.xena_post_ba) AS NumberOfAnswerss FROM xf_thread
		LEFT JOIN xf_user ON xf_user.user_id = xf_thread.xena_userid_ba 
		WHERE xf_user.user_id = xf_thread.xena_userid_ba AND xf_thread.node_id = '$forum_id' 
		GROUP BY xf_user.username
		ORDER BY COUNT(xf_thread.xena_post_ba) DESC;
		");

		return $threads;
	}
}
